#!"\xampp\perl\bin\perl.exe"
# configure Apache for current folder # Bookmarks: 0,0 0,0 0,0 0,0 0,0 0,0 0,0 0,0 0,0 58,26

use strict;
my ($t,@t,$f,$dpath,$wpath,$tpath,$spath,$hostname,$libpath,$pos,@files,$file,@l);

#get paths
$wpath="/xampp/web-gui";                        # does not work with perl cfg.pl
$dpath="$wpath/data";                        # path current working dir, use this   (=folder path/data)
print "wpath: $wpath\n";
print "dpath: $dpath\n";

$tpath="$wpath/tmp";
print "tpath: $tpath\n";

$spath="$dpath/cs_server";
print "spath: $spath\n";

$libpath="\"$dpath/cs_server/CGI\"";
print "libpath: $libpath\n";

$hostname=`hostname`;    chomp($hostname);
print "hostname: $hostname\n\n";

# Apache paths: httpd.conf and extra/httpd-ssl.conf with correct paths for apache.
&update_webserver;

# files: admin.pl and all files in _lib/windows and _lib/windows/scripts
# script to set paths. This allows the web-gui folder to be portable in path and name
# datapath    $dpath=$dpath;      - > dpath=C:/xampp/web-gui/data;    (=current folder)
# web-guipath $wpath=$wpath;      - > dpath=C:/xampp/web-gui;         (=parent folder)
# libpath     use lib $libpath;   ->  use lib "C:/xampp/web-gui/remote_cs_server/CGI";

# admin.pl
$file="$dpath/wwwroot/cgi-bin/admin.pl";
&update_file($file);

# admin-mon.pl
$file="$dpath/wwwroot/cgi-bin/admin-mon.pl";
&update_file($file);

#backend server
$file="$dpath/cs_server/server.pl";
&update_file($file);


#monitor.pl
$file="$dpath/cs_server/monitor.pl";
&update_file($file);

# adjust bat
# copy web-gui start/stop to \xampp
$t=$dpath; $t=~s/\//\\/g;                  # backslash
`copy "$t\\start_zfs-gui_as_admin.bat" C:\\xampp /y`;
`copy "$t\\stop_zfs-gui_as_admin.bat" C:\\xampp /y`;

#xammp start.bat with datapath as working directory
$file="/xampp/start_zfs-gui_as_admin.bat";
&update_bat($file);

#xammp stop.bat with datapath as working directory
$file="/xampp/stop_zfs-gui_as_admin.bat";
&update_bat($file);

#start.bat with datapath as working directory
$file="$dpath/start.bat";
&update_bat($file);

# get all files in $dpath/menues/_lib/windows
#$t=`Get-ChildItem "$dpath/menues/_lib/windows | Select-Object Name`;         # optional

$t="$dpath/menues/_lib/windows";
$t=~s/\//\\/g;                   # cmd dir requ backslash
$t=`dir $t /b /a-d`;             # files only

@files=split(/\n/,$t);
foreach $f (@files) {
   #print "file: $f\n";
   &update_file("$dpath/menues/_lib/windows/$f");
}

# get all files in $dpath/menues/_lib/windows/scripts
$t="$dpath/menues/_lib/windows/scripts";
$t=~s/\//\\/g;                   # cmd dir requ backslash
$t=`dir $t /b /a-d`;             # files only

@files=split(/\n/,$t);
foreach my $f (@files) {
   #print "file=$f\n";
   &update_file("$dpath/menues/_lib/windows/scripts/$f");
}


#update links
&update_links;

#update links
&update_perm;

#update other settings (defaults, activity, tmpfiles etc)
&update_other;

################# other settings
sub update_other {
#################

  # delete ..\tmp files
  $t="$wpath/tmp/*.*"; $t=~s/\//\\/g;
  `del $t /q`;

  #then set activity marker for monitor to generate .stat files
  open(FH,">$wpath/tmp/activity.log") or die $!;
    print FH "1";
  close(FH);

  # del tmp files
  $t=$tpath; $t=~s/\//\\/g;          # backslash required
  print "del /s /q $t\*.*\n";
  `del /s /q $t\*.*`;

  # del running files
  $t="$wpath/_log/jobs"; $t=~s/\//\\/g;          # backslash required
  print "del /s /q $t\*.running\n";
  `del /s /q $t\*.running`;


  # opt copy /cs_server/server.auth to /cfg/server.auth
  ###########################################################
  if ((-f "$dpath/cs_server/server.auth") && (!(-f "$wpath/cfg/server.auth"))) {
     $t="$dpath/cs_server/server.auth $wpath/cfg"; $t=~s/\//\\/g;
     print "\n####### update server.auth location\ncopy $t\n";

     `copy $t`;
     $t="$dpath/cs_server/server.auth"; $t=~s/\//\\/g;
     `del /q $t`;
  }
}  #/other


############
sub update_links {

        print "#######################\nlinks\n";
        # ps>  new-item -itemtype symboliclink -path $wpath\data\wwwroot\_my -target $wpath\_my\wwwroot    # powershell
        # cmd> mklink /d c:\temp\link d:\data

        # del link $wpath/data/wwwroot/_my -> $wpath/_my/wwwroot
        $t="$wpath/data/wwwroot/_my"; $t=~s/\//\\/g;
        print "rd /s /q $t\n";
        `rd /s /q  $t`;            # quiet mode without content

        # cmd> create link current $wpath/data/wwwroot/_my -> $wpath/_my/wwwroot
         $t="$wpath"; $t=~s/\//\\/g;
         print "mklink /d $t\\data\\wwwroot\\_my $t\\_my\\wwwroot\n";
        `mklink /d $t\\data\\wwwroot\\_my $t\\_my\\wwwroot`;
        sleep(2);

}

sub update_perm {       # data/* read all, ./_log rw admin only
##########
        print "\n#######################\nset permissions\n";

}
###############
sub update_bat {
###############
  # update cd  with cd to dpath

  my $file=$_[0];
  $file=~s/\//\\/g;           # use backslash in bat
  my $data=`type $file`;
  my $path=$dpath;
  $path=~s/\//\\/g;

  if (!($data=~/\w/))  { print "81 empty file $file\n"; exit; }

  print "update file.bat $file\n";
  my @data=split(/\n/,$data);
  foreach my $d (@data) {
        #=dpath;
        if ($d=~/^cd /)  {
           $d="cd $path";
        }
  }
  $t=join("\n",@data);

  open(FH,">$file") or die $!;
    print FH $t;
  close(FH);
  return;
}

###############
sub update_file {
###############
  my $file=$_[0];
  $file=~s/\//\\/g;
  my $data=`type $file`;
  if (!($data=~/\w/))  { print "108 empty file $file\n"; exit; }

  print "update file $file\n";
  my @data=split(/\n/,$data);

  foreach my $d (@data) {
        #=dpath;
        if ($d=~/^\$dpath=/)  {
           $d="\$dpath=\"$dpath\";";
        }

        #=wpath;
        if ($d=~/^\$wpath=/)  {
           $d="\$wpath=\"$wpath\";";
        }

        #=tpath;
        if ($d=~/^\$tpath=/)  {
           $d="\$tpath=\"$tpath\";";
        }

        #=spath;
        if ($d=~/^\$spath=/)  {
           $d="\$spath=\"$spath\";";
        }

        #=hostname;
        if ($d=~/^\$hostname=/)  {
           $d="\$hostname=\"$hostname\";";
        }
         #=libpath;
        if ($d=~/^use lib /)  {
           $d="use lib $libpath;";
        }

  }




  $t=join("\n",@data);

  open(FH,">$file") or die $!;
    print FH $t;
  close(FH);
  return;
}

#####################
sub update_webserver {
#####################
       # 1. set wwwroot and cgipath in apache httpd.conf
       $t="/xampp/apache/conf/httpd.conf";                 # update default apache file
       $t=~s/\//\\/g;                                      # use backslash

       #print "\nsetup $t\n------\n";
       $t=`type $t`;

       if (!($t=~/\w/))  { print "152 empty file $t\n"; exit; }
       @l=split(/\n/,$t);

       for (my $i=0;$i<@l;$i++) {
           if ($l[$i]=~/^DocumentRoot /)  {              # set DocumentRoot
               $l[$i]="DocumentRoot \"$dpath/wwwroot\"";
               $l[$i]=~s/\\/\//g;                        # slash not backslash
               #print "$l[$i]\n";

               $l[$i+1]="<Directory \"$dpath/wwwroot\">";
               $l[$i+1]=~s/\\/\//g;                      # slash not backslash
               #print "$l[$i+1]\n";
           }

           # <Directory "/xampp/web-gui/data/wwwroot/cgi-bin">
           if (($l[$i]=~/^<Directory /) && ($l[$i]=~/wwwroot.cgi\-bin/)) {
              $l[$i]="<Directory \"$dpath/wwwroot/cgi-bin\">";
              $l[$i]=~s/\\/\//g;                                             # slash not backslash
              #print "$l[$i]\n"
           }

           # script alias
           #    ScriptAlias /cgi-bin/ "/xampp/napp-it/data/wwwroot/cgi-bin/"
           if ($l[$i]=~/^ +ScriptAlias \/cgi\-bin\/ /)  {                    # set DocumentRoot
               $l[$i]="    ScriptAlias /cgi-bin/ \"$dpath/wwwroot/cgi-bin/\"";
               $l[$i]=~s/\\/\//g;                                            # slash not backslash
               #print "$l[$i]\n";
           }
       }

       # copy to \xampp\apache\conf\httpd.conf
       $t=join("\n",@l);

       print "update \\xampp\\apache\\conf\\httpd.conf\n";
       open(FH,'>\\xampp\\apache\\conf\\httpd.conf') or die $!;
         print FH $t;
       close(FH);

       ########################
       # 2. set wwwroot and cgipath in apache httpd-ssl.conf
       $t="/xampp/apache/conf/extra/httpd-ssl.conf";
       $t=~s/\//\\/g;
       $t=`type $t`;                         # use backslash

       if (!($t=~/\w/))  { print "204 empty file\n"; exit; }

       @l=split(/\n/,$t);

       for (my $i=0;$i<@l;$i++) {
           if ($l[$i]=~/^DocumentRoot /)  {              # set DocumentRoot
               $l[$i]="DocumentRoot \"$dpath/wwwroot\"";
               $l[$i]=~s/\\/\//g;                        # slash not backslash
               print "$l[$i]\n";
           }

       }

       # copy to \xampp\apache\conf\\extra\httpd-ssl.conf
       $t=join("\n",@l);

       print "update \\xampp\\apache\\conf\\extra\\httpd-ssl.conf\n";
       open(FH,'>\\xampp\\apache\\conf\\extra\\httpd-ssl.conf') or die $!;
         print FH $t;
       close(FH);
}


##
1;