#!
# (c) Guenther Alka 2017-124 cs
use strict;         # check for proper code

# slot map for 1..6 maps
# slot numbering: nn.nn.nn (map.row.pos), ex 02.01.04
# list last saved state (do not read live values)


###############
sub my_action {
###############     build actions according to this template

# declare all your variables as local or you will get errors
my ($out,$var,$k,$v,@s,$r,$p,$nr,$map,$maps,@d,$d,$row,$pos,$rows,$cols);

# in %p
# map1_type    # chenbro_50
# map1_slot    # C0e1S0 or c1t1d0

&load_lib("disklib.pl");

# no update with current sasircu data
#if ($cfg{'ver'}=~/c/) { &load_lib("get-disk-sas2.pl"); }
#read smart values
#&my_read_smart;          # do not re-read for a simple map listing

# collect all needed infos to %p to make editing easier
%p=();                                           # parameter for map
$p{'all_dsk'}=$disk{'all'};                  # current disks ec from format
#$p{'all_lsi'}=$disk{'all_lsi'};                  # wwn
#$p{'all_nlsi'}=$disk{'all_nlsi'};                # port numbers like c1t1d0
$p{'all_replaceable'}=$disk{'all_replaceable'};  # all disks from zpool status (used by a pool)

 ####################
 # read all map files        01..09
 ####################

 for ($nr=1;$nr<=9;$nr++) {

     $map=$nr;
     if ($map < 10) { $map="0$map";  $map=~s/^0+/0/; } # map 01 .. 06

     ##
     #######################
     #map 1 type
     # read map typeinfo from config file /_log/maps/map1_type.txt
     # ex
     # 0 type    ex 3h
     # 1 rows
     # 2 cols
     # hide      ex 00,01
     # nvme      opt ex 02,03
     # Text      ex SM 16bay
     # Desc      neues Case mit 12G

     @t=();
     if (-f " $wpath/_my/maps/$in{'member'}/map$map\_type.txt") {
        &read_ahfile(" $wpath/_my/maps/$in{'member'}/map$map\_type.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        $t="map$map\_type";   $p{$t}=$t[0];
        $t="map$map\_rows";   $p{$t}=$t[1];
        $t="map$map\_cols";   $p{$t}=$t[2];
        $t="map$map\_hide";   $p{$t}=$t[3];
        $t="map$map\_nvme";   $p{$t}=$t[4];
        $t="map$map\_text";   $p{$t}=$t[5];
        $t="map$map\_desc";   $p{$t}=$t[6];
        $p{'all_maps'}.="$map\t";
     }

     #set cols and rows of this map
     $rows="map$map"."_rows";
     $rows=$p{$rows};

     $cols="map$map"."_cols";
     $cols=$p{$cols};

     ###########################################################################
     # read slotmap
     # read map slotinfo from config file /_log/maps/map1_slot.txt
     # each line is a row, slots are separated with \t

     @t=();
     if (-f "$wpath/_my/maps/$in{'member'}/map$map\_slot.txt") {
        &read_ahfile("$wpath/_my/maps/$in{'member'}/map$map\_slot.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        # &print_array(@t);

        for (my $row=0;$row<@t;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # pos 0 ..n
                for (my $pos=0;$pos<@s;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    if ($s[$pos] eq "") { next; }

                    $t="enc_of_slot_$map\.$row\.$pos";
                    $p{$t}=$s[$pos];

                    # revers disk_in_slot{'slot'}=>id        # wwn only
                    $t="last_disk_in_slot_$map\.$row\.$pos";
                    $d="$s[$pos]"."_disk";                   # $s=pos

                    #debug
                    #print "$s[$pos] => $disk{$d} <br>";

                    if ($d=~/:/) {
                         $p{$t}=$disk{$d};                   # -> wwn disk
                     } else {
                         $p{$t}=$s[$pos];                          # -> port like c0t0t0
                     }

                    # $p{'map1_slot_00.02'}=c1...
                    $p{'all_known_slots'}.="$map\.$row\.$pos\t";
                }
        }

     }

     ###########################################################################
     # read list of last id/wwn with current  disk_in_slot
     # keep missing id intact

     # read last map WWN info from config file /_log/maps/map1_id.txt
     # this info is used only in case a disks is missing to display the location of a damaged disk
     # each line is a row, valuse are separated with \t

     @t=();
     if (-f "$wpath/_my/maps/$in{'member'}/map$map\_id.txt") {
        &read_ahfile("$wpath/_my/maps/$in{'member'}/map$map\_id.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        for (my $row=0;$row<$rows;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # slots 0 ..n

                for (my $pos=0;$pos<$cols;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    # check if there is a disk in this slot
                    # disk_in_slot_01.00.23        ->         'c2t0d0'

                    $t="last_disk_in_slot_$map\.$row\.$pos";
                    if ($p{$t}=~/c/) {
                          $p="last_disk_in_slot_$map\.$row\.$pos";
                          $p{$p}=$p{$t};                              # current disk will be last disk
                          $s[$pos]=$p{$t};                            # save current disk

                    } else {
                          $t="last_disk_in_slot_$map\.$row\.$pos";    # keep former last disk intact
                          $p{$t}=$s[$pos];                            # =c1...
                    }

                }
                $t[$row]=join("\t",@s);
                #&print_array(@s);
        }

        #&print_array(@t);
        # update id.txt

        foreach my $t (@t) { $t.="\n"; }
        &array2file("t","$wpath/_my/maps/$in{'member'}/map$map\_id.txt");
     }


     ###########################################################################
     # read slotinfo
     # read map slotinfo from config file /_log/maps/map1_info.txt
     # each line is a row, slots are separated with \t

     @t=();
     if (-f "$wpath/_my/maps/$in{'member'}/map$map\_info.txt") {
        &read_ahfile("$wpath/_my/maps/$in{'member'}/map$map\_info.txt","t","b");
        foreach my $t (@t) { chomp ($t); }

        # &print_array(@t);

        for (my $row=0;$row<@t;$row++) {
                @s=();
                @s=split(/\t/,$t[$row]);                             # pos 0 ..n
                for (my $pos=0;$pos<@s;$pos++) {
                    if ($row < 10) { $row="0$row";  $row=~s/^0+/0/; if ($row eq "0") { $row="00";} }
                    if ($pos < 10) { $pos="0$pos";  $pos=~s/^0+/0/; if ($pos eq "0") { $pos="00";} }

                    if ($s[$pos] eq "") { next; }

                    $t="info_of_slot_$map\.$row\.$pos";
                    $p{$t}=$s[$pos];

                }
        }

     }


  } #/read maps 1..n
  ##############################################################################
  $p{'all_known_slots'}=~s/\t+$//;

  my @slots=split(/\t/,$p{'all_known_slots'});
  my ($enc,$id,$prod,$cap,$sn,$pool,$vdev,$target,$sn,$info,$state,$error,$cap2,$temp);

  my $td1="td style='padding-left:15px;border-top:1px solid'";
  my $td ="td style='padding-left:15px'";

  print "<h3>Slots</h3><br>";
  print "<table style='width:800px'>";

  # smart
  # c1t5000CCA22BC92D3Ed0_smart_firmware  ->         'MJAOA3B0'
  # c1t5000CCA22BC92D3Ed0_smart_health    ->         'PASSED'
  # c1t5000CCA22BC92D3Ed0_smart_model     ->         'Hitachi HDS724040ALE640'
  # c1t5000CCA22BC92D3Ed0_smart_selftest  ->         'without error'
  # c1t5000CCA22BC92D3Ed0_smart_sn        ->         'PK1311PAGN5U6X'
  # c1t5000CCA22BC92D3Ed0_smart_support   ->         'available, enabled'
  # c1t5000CCA22BC92D3Ed0_smart_type      ->         'sat,12'
  # c1t5000CCA22BC92D3Ed0_temp            ->         '27'

  my ($fw,$he,$self,$supp,$type);
#&print_hash(%p);
  foreach my $slot (@slots) {

      #map
      $t="enc_of_slot_$slot";   $enc=$p{$t};
      $t="last_disk_in_slot_$slot";  $id=$p{$t};
      $t="info_of_slot_$slot";  $info=$p{$t};
      $info=~s/<n>/ /gs;                                # line breaks

      #disk
      $t="$id"."_product";      $prod=$disk{$t};
      $t="$id"."_partcap";      $cap=$disk{$t};
      $t="$id"."_partcap2";     $cap2=$disk{$t};
      $t="$id"."_sn";           $sn=$disk{$t};
      $t="$id"."_pool";         $pool=$disk{$t};
      $t="$id"."_vdev";         $vdev=$disk{$t};
      $t="$id"."_state";        $state=$disk{$t};
      $t="$id"."_target";       $target=$disk{$t};
      if ($target > 0) { $target="target $target"; }  else { $target='&nbsp'; }
      $t="$id"."_error";        $error=$disk{$t};

      #smart
      $t="$id"."_temp";           $temp=$disk{$t};
      $t="$id"."_smart_support";  $supp=$disk{$t};
      $t="$id"."_smart_health";   $he=$disk{$t};
      $t="$id"."_smart_selftest"; $self=$disk{$t};
      $t="$id"."_smart_type";     $type=$disk{$t};

      if ($self eq "ERROR")     { $self="<font style='color:red; font-weight:bold'>ERROR</font>"; }
      if ($state=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/s) { $state="<font style='color:red; font-weight:bold'>$state</font>"; }

      print <<EoF;
      <tr><$td1><b>Slot $slot</b></td>    <$td1>$enc </td>   <$td1>$id   </td>  <$td1>$prod </td>  <$td1>$sn   </td>  <$td1>$cap </td> </tr>
      <tr><$td>$state\&nbsp;     </td>    <$td>$target </td> <$td>$pool  </td>  <$td>$vdev  </td>  <$td>$error </td>  <$td>$cap2 </td> </tr>
      <tr><$td>&nbsp;            </td>    <$td>Smart: $temp</td>         <$td>Smart health, selftest, type:  </td>  <$td>$he </td>  <$td>$self </td>  <$td>$type </td> </tr>
      <tr><$td>\&nbsp;           </td>    <$td colspan="5"> <b>$info</b> \&nbsp;<br><br>                                   </td></tr>

EoF
  }
  print "</table>";
  print "<script language='javascript'>document.getElementById('hl').innerHTML='List last saved state of maps (without a re-read of current state)'</script>\n";
  &log_end;

  # debug
  #&print_array(@slots);
  #&print_hash(%p);
  #&print_hash(%in);


} #/action

################### include smartvalues
sub my_read_smart {
###################
&mess('todo');
#load smart
     my ($r,$last,$diff,$disk1,$disk2);

     if (-f '/tmp/nappit/napp-it_smart.last')  { $last=&exe("cat /tmp/nappit/napp-it_smart.last"); }
     $diff=time();
     if ($last >0) { $diff=$diff-$last; }

     # maxold=60min = 120/3600s
     if ($diff > 600) {
         print "Smartvalues are too old, re-read smartvalues<hr>";
         $in{'l2'}="15_Smartinfo=-lin";
         $in{'l3'}="04_get smartvalues";
         sleep(1);
         &reload;
     }

     # background job?
     $r=`ps axw | grep get-disk-smart-bg.pl | grep -v grep`;
     if ($r ne "") {
           print "<script language='javascript'>\$('#hl').html('Get Smartvalues)')</script>\n";
           print "get-smart- background job is running, please wait..";
           while ($r ne "") {
                 sleep(4);
                 if (-f "/tmp/nappit/napp-it_smart.txt") {
                    $t="";
                    open (FILE, "/tmp/nappit/napp-it_smart.txt");
                       flock(PF, LOCK_EX);
                       while(<FILE>) {
                          $t = $_ if eof;
                       }
                    close (PF);
                    &log_add_mini($t);
                 }
                 $r=`ps axw | grep get-disk-smart-bg.pl | grep -v grep`;
                 print ".";
           }
     }


     ## read values
     if ((-f "/tmp/nappit/napp-it_smart.txt") && (-f "/tmp/nappit/napp-it_disks.txt")) {
              $disk1=&exe("cat /tmp/nappit/napp-it_disks.txt");
              $disk2=&exe('iostat -En | grep Vendor');

              #Command window
              &log_add("40 compare /tmp/nappit/napp-it_disks.txt vs iostat -En | grep Vendor <hr>$disk1<hr>$disk2");

              #up to date?
              #&mess("$disk1<hr>$disk2");

              if ($disk1 eq "$disk2") {
                   #load smart_temp to %disk
                   &read_ahfile("/tmp/nappit/napp-it_smart.txt","disk","h+");

                   #get disk'unused' from all disks,..
                   &get_mydsk_stat;

                   &log_add(" 327# compare /tmp/nappit/napp-it_disks.txt vs iostat -En | grep Vendor <hr>identical, use buffered smart info");
              }
    }
    ###########

}

###############################################
#end of my script, do not delete the line below
1;
